#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	mesa
Version		:	24.0.3
Release		:	16.2.0.rel%{?dist}
summary		:	Mesa graphics libraries
Group		:	System Environment/Libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	MIT
URL		:	https://mesa.freedesktop.org
			# https://archive.mesa3d.org/

Source0		:	%{name}-%{version}.tar.xz
Patch0		:	%{name}-%{version}-add_xdemos-2.patch 

#-----------------------------------------------------------------------------
BuildRequires	:	elfutils-devel
BuildRequires	:	gettext
BuildRequires	:	libdrm
BuildRequires	:	libunwind-devel
BuildRequires	:	libva
BuildRequires	:	libvdpau
BuildRequires	:	llvm-devel
BuildRequires	:	llvm-clang-devel
BuildRequires	:	make-ca
BuildRequires	:	meson
BuildRequires	:	python3-Mako
BuildRequires	:	python3-MarkupSafe
BuildRequires	:	rustc
BuildRequires	:	rust-bindgen
BuildRequires	:	valgrind-devel
BuildRequires	:	xorg-libxshmfence
BuildRequires	:	xorg-libXrandr
BuildRequires	:	xorg-libX11,xorg-libXext,xorg-libXdamage,xorg-libXfixes
BuildRequires	:	Vulkan-Loader
BuildRequires	:	wayland,wayland-protocols
BuildRequires	:	xcb-util-keysyms
BuildRequires	:	xorg-libXxf86vm
BuildRequires	:	xorg-libXvMC
#-----------------------------------------------------------------------------
Requires	:	wayland
#-----------------------------------------------------------------------------
Provides	:	xorg-libGL
#-----------------------------------------------------------------------------
%description
Direct Rendering Manager development package

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%{_bindir}/glxgears
%{_bindir}/glxinfo
%{_libdir}/d3d/d3dadapter9.so*
%{_libdir}/dri/*.so*
%{_libdir}/libOSMesa.so*
%{_libdir}/libEGL.so*
%{_libdir}/libGL.so*
%{_libdir}/libGLESv1_CM.so*
%{_libdir}/libGLESv2.so*
%{_libdir}/libgbm.so*
%{_libdir}/libglapi.so*
%{_libdir}/libxatracker.so*
%{_libdir}/vdpau/libvdpau_*.so*
%{_libdir}/libvulkan_nouveau.so
%{_libdir}/libvulkan_virtio.so
%{_datadir}/drirc.d/00-%{name}-defaults.conf
%{_datadir}/vulkan/icd.d/*_icd.x86_64.json
%{_mandir}/man1/glx*.1.gz

#-----------------------------------------------------------------------------
%postun
/usr/sbin/ldconfig

%post
/usr/sbin/ldconfig

#=============================================================================
%package		devel

Summary		:	Mesa libGL development package

Requires	:	%{name}		=	%{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
Mesa libGL development package

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/*.h
%{_includedir}/EGL/*.h
%{_includedir}/GL/*.h
%{_includedir}/GL/internal/*.h
%{_includedir}/GLES/*.h
%{_includedir}/GLES2/*.h
%{_includedir}/GLES3/*.h
%{_includedir}/KHR/*.h
%{_includedir}/d3dadapter/*.h
#{_includedir}/vulkan/vulkan_intel.h
%{_libdir}/pkgconfig/*.pc

#=============================================================================
%prep
%setup -q -n %{name}-%{version}
%patch -P 0 -p1

#-----------------------------------------------------------------------------
%build

#GLL_DRV="crocus,i915,iris,nouveau,r300,r600,radeonsi,svga,swrast,virgl,zink"
GLL_DRV=crocus,i915,iris,nouveau,r300,r600,radeonsi,svga,swrast,virgl
VUL_DRV=nouveau-experimental,virtio

meson							\
	setup						\
        --prefix=%{_prefix}				\
	--buildtype=release 				\
	-D platforms=x11,wayland			\
	-D gallium-drivers=${GLL_DRV}			\
	-D vulkan-drivers=${VUL_DRV}			\
	-D valgrind=enabled				\
	-D libunwind=enabled				\
							\
	-D gallium-nine=true				\
	-D glx=dri					\
	-D llvm=enabled 				\
	-D opengl=true					\
	-D osmesa=true					\
	_bld


%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
ninja 							\
	-C _bld						\
	%{_smp_mflags}

unset GLL_DRV DIR_DRV

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot}					\
	ninja						\
	-C _bld						\
	install

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
